<template>
  <div class="mb-3">
    <v-card tile>
      <crud-data-table
        :headers="headers"
        :items="amounts"
        :loading="isLoading"
        sort-by="referenceMonth"
        :items-per-page="-1"
        hide-default-footer
        hide-slot-top
        dense
      >
        <template v-slot:confirmationToDelete>
          <delete-income-amount-dialog
            @onDeleteIncomeAmount="onDeleteIncomeAmountCallback = $event"
          />
        </template>

        <template v-slot:referenceMonth="props">
          <update-reference-month-dialog
            v-model="props.item.referenceMonth"
            :item-id="props.item.id"
            :min-date="minDate"
            :max-date="maxDate"
          />
        </template>

        <template v-slot:amount="props">
          <update-amount-dialog
            v-model="props.item.amount"
            :item-id="props.item.id"
          />
        </template>

        <!--        <template v-slot:isPaymentConfirmed="props">-->
        <!--          <update-is-payment-confirmed-dialog-->
        <!--            v-model="props.item.isPaymentConfirmed"-->
        <!--            :item-id="props.item.id"-->
        <!--          />-->
        <!--        </template>-->

        <template v-slot:dueDate="props">
          <update-due-date-dialog
            v-model="props.item.dueDate"
            :item-id="props.item.id"
            :min-date="minDate"
            :max-date="maxDate"
          />
        </template>

        <template v-slot:paymentReceivedAt="props">
          <update-payment-received-at-dialog
            v-model="props.item.paymentReceivedAt"
            :item-id="props.item.id"
            :min-date="minDate"
            :max-date="maxDate"
          />
        </template>

        <template v-slot:createdAt="{ item: { createdAt } }">
          {{ createdAt | formatDateToRelativeTime }}
        </template>

        <template v-slot:updatedAt="{ item: { updatedAt } }">
          {{ updatedAt | formatDateToRelativeTime }}
        </template>

        <template v-slot:delete="{ item }">
          <delete-icon-btn
            small
            @click="onDeleteIncomeAmountCallback(item)"
          />
        </template>
      </crud-data-table>
    </v-card>
    <create-amount :income-id="incomeId" />
  </div>
</template>

<script>
  import DatesMixin from '@/mixins/date'
  import getTableHeaders from './table-headers'
  // components
  import CreateAmount from './crud/Create'
  import DeleteIncomeAmountDialog from './crud/Delete'
  import UpdateReferenceMonthDialog from './crud/UpdateReferenceMonth'
  import UpdateDueDateDialog from './crud/UpdateDueDate'
  import UpdatePaymentReceivedAtDialog from './crud/UpdatePaymentReceivedAt'
  import UpdateAmountDialog from './crud/UpdateAmount'
  // import UpdateIsPaymentConfirmedDialog from './crud/UpdateIsPaymentConfirmed'
  import { get } from 'vuex-pathify'

  export default {
    name: 'AmountsTable',
    components: {
      CreateAmount,
      DeleteIncomeAmountDialog,
      UpdateReferenceMonthDialog,
      UpdateDueDateDialog,
      UpdatePaymentReceivedAtDialog,
      UpdateAmountDialog,
      // UpdateIsPaymentConfirmedDialog,
    },
    mixins: [DatesMixin],
    props: {
      incomeId: {
        type: Number,
        required: true,
      },
      amounts: {
        type: Array,
        required: true,
      },
    },
    data () {
      return {
        onDeleteIncomeAmountCallback: null,
        headers: getTableHeaders(key => this.$t(key)),
      }
    },
    computed: {
      ...get('incomeAmounts', [
        'isLoading',
      ]),
      selectedPeriod () {
        return this.$store.getters['periods/getSelectedPeriod']
      },
      minDate () {
        return this.selectedPeriod.startDate
      },
      maxDate () {
        return this.selectedPeriod.endDate
      },
    },
  }
</script>
